'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

const React = require('react');

const MextContext_1 = require('mext-utils/MextContext');
/**
 * 获取mext context数据
 
 ```
<Consumer>
  {(mext)=>{
    // setMext的数据传递到这里
    console.log(mext);
  }}
</Consumer>
 ```
 */

class Consumer extends React.Component {
  shouldComponentUpdate() {
    return false;
  }

  render() {
    return React.createElement(MextContext_1.default.Consumer, null, mext => {
      return this.props.children(mext);
    });
  }
}

exports.default = Consumer;
