import Lifecycle from './lifecycle';
export default class KernalComponent extends Lifecycle {
    /**
     * 该Provider只提供初始化组件时的数据传递，该组件状态将不再更新
     *
     * 把客户端入口整理的数据，通过context传递给路由RouterSwitch组件使用
     * 同理，服务端也有类似的组件
     */
    provider(): (props: any) => JSX.Element;
    /**
     * 提供路由的Router渲染，根据配置，选择history还是hash类型的路由
     */
    router(): (props: any) => JSX.Element;
    /**
     * 所有的路由组件切换生命周期钩子，都是依赖Prompt组件
     * 再配合Router上的getUserConfirmation钩子，实现了路由切换的逻辑处理
     */
    prompt(): () => JSX.Element;
    /**
     * 根组件之高阶组件
     *
     * 提供全局错误处理
     * 回到顶部
     */
    root(): any;
}
