'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
/**
 * 利用中间件模型，处理每次路由切换的业务逻辑
 */

class LifeCycleMiddleware {
  constructor() {
    this.stack = [];
  }

  use(fun) {
    this.stack.push(fun);
  }

  async start(ctx = {}) {
    if (this.stack.length) {
      const func = this.stack.shift();

      if (typeof func === 'function') {
        await func(ctx, this.start.bind(this, ctx));
      }
    }
  }

  listen() {
    this.start();
  }
}

exports.default = LifeCycleMiddleware;
