'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
/**
 * 路由发生变化，根组件钩子函数处理中间件
 */

const routerLifecycle_1 = require('../../utils/routerLifecycle');

function routerWillUpdateMiddleware() {
  return async (ctx, next) => {
    /**
     * 执行路由跳转前routerWillUpdate生命周期钩子的触发
     */
    if (
      !(await routerLifecycle_1.routerWillUpdate({
        to: ctx.target,
        from: ctx.lastTarget,
        history: this.history,
        data: this.getInitialState()
      }))
    ) {
      return ctx.cb(false);
    } // 存储参数

    this.setParam(ctx.targetLocation);
    await next();
  };
}

exports.default = routerWillUpdateMiddleware;
