'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

const react_router_1 = require('react-router');

exports.default = async (match_routes, matchLength, url) => {
  let redirectUrl = null;

  if (!matchLength) {
    return null;
  } // 只关心最后一级路由上的 redirect

  const { match, route } = match_routes[matchLength - 1];

  if (route.redirect) {
    const redirect = route.redirect;

    if (typeof redirect === 'function') {
      redirectUrl = await redirect(url, match);
    } else if (typeof redirect === 'string') {
      redirectUrl = react_router_1.generatePath(redirect, match.params);
    }

    if (redirectUrl && redirectUrl !== url) {
      return redirectUrl;
    }
  }

  return null;
};
