'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

const loadParams_1 = require('mext-utils/loadParams');

const initial_state_1 = require('./shared/initial_state');

let setMext = null;
/**
 * 客户端全局store
 */

exports.default = data => {
  if (typeof data === 'function') {
    // 存储setMext方法
    setMext = data;
  } else {
    if (process.env.RUN_ENV === 'node') {
      // 如果发现在服务器上执行该方法，说明有问题
      console.warn('setMext方法在服务端不生效');
    } else {
      const { firstRender } = loadParams_1.default.get();

      if (firstRender) {
        // 首次渲染，说明还未渲染出setMext处理组件，需要把数据传给INITIAL_STATE
        if (data && data.constructor === Object && Object.keys(data).length) {
          initial_state_1.INITIAL_STATE.mext = { ...initial_state_1.INITIAL_STATE.mext, ...data };
        } else {
          console.warn('setMext必须接受一个不为空的对象');
        }
      } else {
        if (typeof setMext === 'function') {
          setMext(data);
        }
      }
    }
  }
};

exports.clean = () => {
  setMext = null;
};
