import * as React from 'react';
import { AComponentType, Ioptions } from 'mext-types';
export interface ErrorProps {
    /**
     * 错误说明
     */
    message: string;
    /**
     * 错误状态码
     */
    status: number;
    /**
     * 当前是否在路由内发生错误
     */
    routerError: boolean;
    stack: any;
    info: any;
    url: any;
    data: any;
}
/**
 *    启动react渲染,只能执行一次，就算后续执行了也不会启任何作用，并且会在控制台进行错误提示
 *    @Component       项目启动入口组件
 *    @ErrorComponent  展示错误的组件
 */
export default function start(Component: AComponentType | React.ComponentElement<any, any>, ErrorComponent?: React.ComponentClass | React.FC<ErrorProps>, options?: Ioptions): any;
